
import re
import os
import math
import numpy as np
import pandas as pd


if __name__ == '__main__':
    files = os.listdir('./data')

    pattern = re.compile(r'-?\d+\.*\d*')

    header = ['TopCurrent',
              'BottomCurrent',
              'Direction',
              'B1',
              'B2',
              'B3',
              'B4',
              'B5',
              'B6',
              'B7',
              'B8',
              'B9',
              'B10',
              'B11',
              'B12',
              'Net.Bottom.Pos2']

    df_save = pd.DataFrame(columns=header)

    for file in files:
        data_path = './data/' + file
        df = pd.read_csv(data_path, header=None, sep=',')

        forces_rawdata = df.iloc[5003:6003].values.astype(float)

        average_forces = np.average(forces_rawdata, axis=0)

        Net_Bottom_Pos2 = average_forces[0]

        B_forces = list()
        ii = 1
        for _ in range(12):
            i_force = math.sqrt(
                math.pow(average_forces[ii], 
                2) + math.pow(average_forces[ii + 1],
                2) + math.pow(average_forces[ii + 2],
                2))
                B_forces.append(i_force)
                ii = ii + 3

        topcurrent = 111

        nums = re.findall(pattern, file)

        df_save = df_save.append({'TopCurrent': float(nums[0]),
                                  'BottomCurrent': float(nums[1]),
                                  'Direction': float(nums[2]),
                                  'B1': B_forces[0],
                                  'B2': B_forces[1],
                                  'B3': B_forces[2],
                                  'B4': B_forces[3],
                                  'B5': B_forces[4],
                                  'B6': B_forces[5],
                                  'B7': B_forces[6],
                                  'B8': B_forces[7],
                                  'B9': B_forces[8],
                                  'B10': B_forces[9],
                                  'B11': B_forces[10],
                                  'B12': B_forces[11],
                                  'Net.Bottom.Pos2': Net_Bottom_Pos2},
                                 ignore_index=True)

    df_save.to_csv('./samples.csv', index=None)

